local me = CreateFrame("frame")

--See http://wowprogramming.com/docs/api_types#specID for what the IDs are
AutoLootSpecSwap_bossNameToSpecMapping = {
}

--0 means stay the same
AutoLootSpecSwap_specToSwitchToAfterLooting = 0

local autoSwapActive = false
local globalDisable = false

local journalSaveButton = CreateFrame("Button", "EncounterJournalEncounterFrameInfoCreatureButton1ALSSSaveButton",UIParent,"UIPanelButtonTemplate")
local journalForgetButton = CreateFrame("Button", "EncounterJournalEncounterFrameInfoCreatureButton1ALSSForgetButton",UIParent,"UIPanelButtonTemplate")

me:RegisterEvent("PLAYER_TARGET_CHANGED")
me:RegisterEvent("LOOT_CLOSED")
local UnitName = _G["UnitName"]
local UnitIsDead = _G["UnitIsDead"]
me:SetScript("OnEvent", function(self, event)
	if(globalDisable) then return end
	local newSpec = nil
	if(event == "PLAYER_TARGET_CHANGED") then
		if(not UnitIsDead("target")) then
			if(UnitIsEnemy("player","target")) then
				local targetName = UnitName("target")
				newSpec = AutoLootSpecSwap_bossNameToSpecMapping[targetName]
				if(newSpec) then
					inDefaultSpecAlready = false
					autoSwapActive = true
				end
			end
		end
	elseif(autoSwapActive and (not (inDefaultSpecAlready--[[ or InCombatLockdown()]]))) then
		autoSwapActive = false
		if(AutoLootSpecSwap_specToSwitchToAfterLooting ~= 0) then
			newSpec = AutoLootSpecSwap_specToSwitchToAfterLooting
			inDefaultSpecAlready = true
		end
	end
	if(newSpec and ((GetLootSpecialization()) ~= newSpec)) then
		if(newSpec == -1) then
			SetLootSpecialization(0)
			print("AutoLootSpecSwap: CHANGED LOOT SPEC TO FOLLOW CURRENT SPEC")
		else
			SetLootSpecialization(newSpec)
			print("AutoLootSpecSwap: CHANGED LOOT SPEC TO: <<"..(select(2,GetSpecializationInfoByID(newSpec)))..">>")
		end
	end
end)

local overrideTarget = nil
function me.SlashCommandHandler(cmd)
	if cmd and string.lower(cmd) == "record" then
		local currSpec = (GetLootSpecialization())
		local currTarget = overrideTarget or UnitName("target")
		
		if(type(currSpec) == "number" and type(currTarget) == "string") then
			if(currSpec == 0) then
				print("AutoLootSpecSwap: Your current specialization is set to 'Current Spec'. You can't save that because it makes no sense to do that. :<")
			else
				AutoLootSpecSwap_bossNameToSpecMapping[currTarget] = currSpec
				print("AutoLootSpecSwap: Recorded <<"..(select(2,GetSpecializationInfoByID(currSpec)))..">> as preferred spec for <<"..currTarget..">>.")
			end
		end
	elseif cmd and string.lower(cmd) == "setdefault" then
		local currSpec = (GetLootSpecialization())
		if(type(currSpec) == "number") then
			AutoLootSpecSwap_specToSwitchToAfterLooting = currSpec
			print("AutoLootSpecSwap: Set default spec to <<"..(select(2,GetSpecializationInfoByID(currSpec)))..">>.")
		end
	elseif cmd and string.lower(cmd) == "setdefaulttofollow" then
		AutoLootSpecSwap_specToSwitchToAfterLooting = -1
		print("AutoLootSpecSwap: Set default spec to follow your actual spec.")
	elseif cmd and string.lower(cmd) == "list" then
		print("AutoLootSpecSwap: List")
		for k,v in pairs(AutoLootSpecSwap_bossNameToSpecMapping) do
			if(type(v) == "number" and type(k) == "string") then
				print(k..": "..(select(2,GetSpecializationInfoByID(v))))
			end
		end
		if(AutoLootSpecSwap_specToSwitchToAfterLooting) then
			if(AutoLootSpecSwap_specToSwitchToAfterLooting == 0) then
				print("Default: <<No default>>")
			elseif(AutoLootSpecSwap_specToSwitchToAfterLooting == -1) then
				print("Default: <<Current Spec>>")
			else
				print("Default: "..(select(2,GetSpecializationInfoByID(AutoLootSpecSwap_specToSwitchToAfterLooting))))
			end
		end
	elseif cmd and string.lower(cmd) == "forget" then
		local currTarget = overrideTarget or UnitName("target")
		if(type(currTarget) == "string") then
			AutoLootSpecSwap_bossNameToSpecMapping[currTarget] = nil
			print("AutoLootSpecSwap: Forgot target <<"..currTarget..">>.")
		end
	elseif cmd and string.lower(cmd) == "forgetdefault" then
		AutoLootSpecSwap_specToSwitchToAfterLooting = 0
		print("AutoLootSpecSwap: Forgot default spec.")
	elseif cmd and string.lower(cmd) == "onff" then
		globalDisable = not globalDisable
		journalSaveButton:SetShown(not globalDisable)
		journalForgetButton:SetShown(not globalDisable)
		print("AutoLootSpecSwap: " .. ((not globalDisable) and "Enabled." or "Disabled."))
	else
		print("AutoLootSpecSwap: Usage:\n/alss record|setdefault|setdefaulttofollow|list|forget|forgetdefault|onff")
	end
end

journalSaveButton:SetScript("OnClick",function(self)
	overrideTarget = EncounterJournalEncounterFrameInfoCreatureButton1.name
	me.SlashCommandHandler("record")
	overrideTarget = nil
end)
journalForgetButton:SetScript("OnClick",function(self)
	overrideTarget = EncounterJournalEncounterFrameInfoCreatureButton1.name
	me.SlashCommandHandler("forget")
	overrideTarget = nil
end)
journalSaveButton:SetWidth(80)
journalSaveButton:SetHeight(30)
journalSaveButton:SetPoint("CENTER",0,250)
journalSaveButton:SetText("ALSS Save")
journalSaveButton:Hide()
journalForgetButton:SetWidth(80)
journalForgetButton:SetHeight(30)
journalForgetButton:SetPoint("CENTER",0,250)
journalForgetButton:SetText("ALSS Forget")
journalForgetButton:Hide()

SlashCmdList["AUTOLOOTSPECSWAP"] = me.SlashCommandHandler
SLASH_AUTOLOOTSPECSWAP1 = "/autolootspecswap"
SLASH_AUTOLOOTSPECSWAP2 = "/alss"

local loadframe = CreateFrame("frame")
loadframe:RegisterEvent("ADDON_LOADED")
loadframe:SetScript("OnEvent",function(self,event,addon)
	if(addon == "Blizzard_EncounterJournal") then
		journalSaveButton:SetParent(EncounterJournal)
		journalSaveButton:Show()
		journalSaveButton:ClearAllPoints()
		journalSaveButton:SetPoint("TOP",EncounterJournal,"TOP",450,0)
		journalForgetButton:SetParent(EncounterJournal)
		journalForgetButton:Show()
		journalForgetButton:ClearAllPoints()
		journalForgetButton:SetPoint("TOP",EncounterJournal,"TOP",450,-40)
	end
end)


